-- Maze Game

-- initialize
love.keyboard.setKeyRepeat(true)
input = require "input"
maze  = require "maze"
player = {}
keys = {}
map = maze.newMaze()

-- floodfill test
function FloodFill(map, x, y)
    map[x][y] = 0.5
    if x > 1 and map[x-1][y] == maze.path then FloodFill(map, x-1, y) end
    if x < map.w and map[x+1][y] == maze.path then FloodFill(map, x+1, y) end
    if y > 1 and map[x][y-1] == maze.path then FloodFill(map, x, y-1) end
    if y < map.h and map[x][y+1] == maze.path then FloodFill(map, x, y+1) end
end

--~ FloodFill(map, player.x, player.y)


function love.load()

    -- Screen calculations
    local width, height = love.graphics.getDimensions()
    local pixels = math.min(width, height)
    local size = math.max(map.w, map.h) + 2
    map.scale = math.floor(pixels / size)
    player.rad = math.floor(map.scale / 2)
    
    -- key bindings
    keys.up    = input.up
    keys.down  = input.down
    keys.left  = input.left
    keys.right = input.right
    keys.w     = input.up
    keys.s     = input.down
    keys.a     = input.left
    keys.d     = input.right
    keys.escape = love.event.quit
    keys.kpenter = love.event.quit
    keys["return"] = love.event.quit
end

function love.draw()
    
    -- reset graphics
    love.graphics.setColor(1, 1, 1)
    
    -- set background
    love.graphics.clear(0.3, 0.5, 1)
    
    -- draw maze
    for x = 1, map.w do
        for y = 1, map.h do
            local c = map[x][y]
            love.graphics.setColor(c, c, c)
            love.graphics.rectangle("fill", x * map.scale, y * map.scale, map.scale, map.scale)
        end
    end
    
    -- draw player
    love.graphics.setColor(1, 0, 0)
    love.graphics.circle("fill", player.x * map.scale + player.rad, player.y * map.scale + player.rad, player.rad)
end

function love.keypressed(key)
    if keys[key] then keys[key]() end
end
